#!/usr/bin/python
#
# Simson's XML cheat sheat

import xml.dom.minidom
from xml.dom.minidom import parseString

xml = r"""<parts><part><name>leaf</name><color>green</color></part><part id='12'><name>bark</name><color>brown</color></part></parts>"""

doc = parseString(xml)

print "Constants defined:"
node_types = {}
for attr in dir(doc):
    if attr[0].isupper():
        val = getattr(doc,attr)
        print "doc.%s = %d " % (attr,val)
        node_types[val] = attr

print "Show the XML:"
print doc.toxml()

print "To prettyprint:"
print doc.toprettyxml()

print "To get the the <parts> list:"
parts = doc.getElementsByTagName("parts")[0]
print parts.toxml()
print "parts.nodeName = ",parts.nodeName
print "parts.nodeType = ",parts.nodeType,"=",node_types[parts.nodeType]
print "parts.nodeValue = ",parts.nodeValue

print "To get the first part object:"
part1 = doc.getElementsByTagName("part")[0]
print part1.toxml()

"""
doc.nodeName - Returns the name of the first tag
doc.nodeType - Returns the type of the node

Tools for navigating through the XML:
doc.firstChild
doc.nextSibling


doc.lastChild



Tools for getting nodes by name:
getElementsByTagName
GetElementsByTagNameNS

Tools for modifying a doc:
doc.appendNode
doc.cloneNode
doc.removeChild
doc.replaceChild
doc.setAttribute
doc.setAttributeNode

Nodes can be real nodes or text nodes or comments or what have you.

"""
